//	Date and Time Picker ControlTv t@C̏ݓC
//	Visual C++ 2013 32/64bit
#include <windows.h>
#include <commctrl.h> 
#include <time.h>
#include <tchar.h>
#include "resource.h"

TCHAR* file = 0;
LRESULT CALLBACK DlgProc1(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam);
//	t@C̍XV擾_CAOɕ\
HANDLE fileTimeGet(HWND hDlg, TCHAR* fname);

int WINAPI _tWinMain(HINSTANCE hInstance, HINSTANCE hPreInst,
						TCHAR* lpszCmdLine, int nCmdShow){
	TCHAR f[MAX_PATH];
	if (lpszCmdLine[0]){
		TCHAR nullz = _TEXT('\0');
		if (lpszCmdLine[0]){
			if (lpszCmdLine[0] == _T('\"')){
				_tcscpy_s(f, sizeof(f) / sizeof(TCHAR), lpszCmdLine + 1);
				f[_tcslen(f) - 1] = _T('\0');
				file = f;
			}
			else
				file = lpszCmdLine;
		}
	}
	DialogBox(hInstance, TEXT("DLG"), 0, (DLGPROC)DlgProc1);
	return (int)0;
}

//	_CAO{bNXvV[W[

LRESULT CALLBACK DlgProc1(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam){
	TCHAR buf[MAX_PATH];
	static HANDLE hFile=0;
	SYSTEMTIME st,st2;
	FILETIME WriteTime;
	FILETIME localTime;

	switch (msg) {
		case WM_INITDIALOG:{
			DragAcceptFiles(hDlg, TRUE);
			if (file){
				SetWindowText(GetDlgItem(hDlg, IDC_EDIT105), file);
				hFile = fileTimeGet(hDlg, file);
			}
			return TRUE;
		}
		case WM_DROPFILES:{
			HDROP hDrop;
			hDrop = (HDROP)wParam;
			int fmax = DragQueryFile((HDROP)wParam, 0xFFFFFFFF, NULL, 0);
			DragQueryFile(hDrop, 0, buf, sizeof(buf) / sizeof(TCHAR));
			SetWindowText(GetDlgItem(hDlg, IDC_EDIT105),buf);
			DragFinish(hDrop);

			if (hFile)
				CloseHandle(hFile);
			hFile = fileTimeGet(hDlg,buf);
			break;
		}
		case WM_COMMAND:
			switch(LOWORD(wParam)){
				case IDOK:
					if (hFile){
						HWND hDate1 = GetDlgItem(hDlg, IDC_DTP100);
						DateTime_GetSystemtime(hDate1,&st);
						HWND hTime1 = GetDlgItem(hDlg, IDC_DTP102);
						DateTime_GetSystemtime(hTime1, &st2);
						st.wHour = st2.wHour;
						st.wMinute = st2.wMinute;
						st.wSecond = st2.wSecond;
						SystemTimeToFileTime(&st, &localTime);
						LocalFileTimeToFileTime(&localTime, &WriteTime);
						if (SetFileTime(hFile, &WriteTime, &WriteTime, &WriteTime) == 0){
							MessageBox(hDlg, _TEXT("t@C̓ύXł܂łB"), _TEXT("G["), MB_OK);
						}
						CloseHandle(hFile);
						hFile = 0;
					}
					EndDialog(hDlg, TRUE);
					return TRUE;
				case IDCANCEL:
					if (hFile)
						CloseHandle(hFile);
					EndDialog(hDlg, FALSE);
					return FALSE;
				default:
					return FALSE;
			}
			default:
				return FALSE;
	}
	return TRUE;
}

//	t@C̍XV擾_CAOɕ\

HANDLE fileTimeGet(HWND hDlg, TCHAR* fname){
	SYSTEMTIME st;
	FILETIME CreationTime;
	FILETIME AccessTime;
	FILETIME WriteTime;
	FILETIME localTime;
	HANDLE hFile = CreateFile(fname, GENERIC_WRITE, 0, 0, OPEN_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
	if (hFile == INVALID_HANDLE_VALUE){
		MessageBox(hDlg, _TEXT("t@CJ܂B"), _TEXT("G["), MB_OK);
		return 0;
	}
	//	݂̃t@C̓擾\
	GetFileTime(hFile, &CreationTime, &AccessTime, &WriteTime);

	FileTimeToLocalFileTime(&WriteTime, &localTime);	//	UTC[J^C
	FileTimeToSystemTime(&localTime, &st);	//	FILETIMESYSTEMTIMEɕϊ
	HWND hDate1 = GetDlgItem(hDlg, IDC_DTP100);
	DateTime_SetSystemtime(hDate1, GDT_VALID, &st);
	HWND hTime1 = GetDlgItem(hDlg, IDC_DTP102);
	DateTime_SetSystemtime(hTime1, GDT_VALID, &st);
	return hFile;
}
